package com.persagy.server.models

import com.alibaba.fastjson.annotation.JSONField
import io.swagger.annotations.ApiModel
import io.swagger.annotations.ApiModelProperty
import java.io.Serializable

/**
 * 已采集信息点统计实体类
 *
 * @author 蒋湘江
 */
@ApiModel(description = "已采集信息点统计实体类")
class GatherInfoPoint:Serializable {

    /** 信息点总数(数字字典+自定义信息点) */
    @ApiModelProperty(value = "信息点总数(数字字典+自定义信息点)")
    @JSONField(name = "GatherInfoPointCounts")
    var gatherInfoPointCounts : Int? = 0

    /** 已采集的动态信息点总数 */
    @ApiModelProperty(value = "已采集的动态信息点总数")
    @JSONField(name = "GatherDynamicInfoPointCounts")
    var gatherDynamicInfoPointCounts : Int? = 0

    /** 已采集的静态信息点总数 */
    @ApiModelProperty(value = "已采集的静态信息点总数")
    @JSONField(name = "GatherStaticInfoPointCounts")
    var gatherStaticInfoPointCounts : Int? = 0

    /** 已采集的自定义信息点总数 */
    @ApiModelProperty(value = "已采集的自定义信息点总数")
    @JSONField(name = "GatherCustomInfoPointCounts")
    var gatherCustomInfoPointCounts : Int? = 0



}// Class GatherInfoPoint