package com.persagy.server.models

import com.persagy.server.datacenter.models.entities.base.BaseInfo
import io.swagger.annotations.ApiModel
import io.swagger.annotations.ApiModelProperty
import javax.persistence.Column
import javax.persistence.Id
import javax.persistence.Table

@ApiModel(description = "系统、设备信息")
@Table(name = "v_equip_system")
class SysEquip : BaseInfo() {

    /** 系统id */
    @ApiModelProperty(value = "系统id",required = true)
    @Id
    @Column(name = "id")
    var id: String? = null

    /** 系统名称 */
    @ApiModelProperty(value = "系统名称")
    @Column(name = "sys_name")
    var name: String? = null

    /** 系统本地名称 */
    @ApiModelProperty(value = "系统本地名称")
    @Column(name = "sys_local_name")
    var localName: String? = null

    /** 系统类型*/
    @ApiModelProperty(value = "系统类型")
    @Column(name = "class_code")
    var classCode: String? = null

    /** 设备id*/
    @ApiModelProperty(value = "设备id")
    @Column(name = "equip_id")
    var equipId: String? = null

    /** 设备名称*/
    @ApiModelProperty(value = "设备名称")
    @Column(name = "equip_name")
    var equipName: String? = null


    /** 设备本地名称*/
    @ApiModelProperty(value = "设备本地名称")
    @Column(name = "equip_local_name")
    var equipLocalName: String? = null

    /** 项目id*/
    @ApiModelProperty(value = "项目id")
    @Column(name = "project_id")
    var projectId: String? = null

} // Class SysEquip