package com.persagy.server.models

import com.alibaba.fastjson.annotation.JSONField
import com.persagy.server.datacenter.models.entities.base.BaseInfo
import io.swagger.annotations.ApiModel
import io.swagger.annotations.ApiModelProperty
import javax.persistence.Column
import javax.persistence.Table

/**
 * 当前设备分类名称
 *
 * @author 张维新
 */
@ApiModel(description = "当前设备分类名称")
@Table(name = "v_equip_component_count")
class VEquipComponentCount : BaseInfo(){

    /** 设备id */
    @ApiModelProperty(value = "设备id",required = true)
    @Column(name = "id")
    @JSONField(name = "Id")
    var id: String? = null

    /** 分类 */
    @ApiModelProperty(value = "分类")
    @Column(name = "category")
    @JSONField(name = "Category")
    var category: String? = null

    /** 分类名称 */
    @ApiModelProperty(value = "分类名称")
    @Column(name = "category_name")
    @JSONField(name = "CategoryName")
    var categoryName: String? = null

    /** 数量 */
    @ApiModelProperty(value = "数量",required = true)
    @Column(name = "count")
    @JSONField(name = "count")
    var count:Long? = null

} // class VEquipComponentCount