/*
 * ********************************************************************************************************************
 *
 *                      :*$@@%$*:                         ;:                ;;    ;;
 *                    :@@%!  :!@@%:                       %!             ;%%@@%$ =@@@@@@@%;     @%@@@%%%%@@@@@
 *                   :@%;       :$=                       %%$$$%$$         ;$$  ;$@=   !@$
 *                   =@!                                  %!              @ $=;%   !@@@%:      !$$$$$$$$$$$$$$=
 *                   =@*                                  %!              @ $= % %@=   =%@!      %=
 *              *$%%! @@=        ;=$%%%$*:                %!              @ $= % =%%%%%%@$      *%:         =%
 *            %@@!:    !@@@%=$@@@@%!  :*@@$:              %!              @ $= % $*     ;@      @*          :%*
 *          ;@@!          ;!!!;:         ;@%:      =======@%========*     @ $$ % $%*****$@     :@$=*********=@$
 *          $@*   ;@@@%=!:                *@*
 *          =@$    ;;;!=%@@@@=!           =@!
 *           %@$:      =@%: :*@@@*       %@=                    Copyright (c) 2016-2019.  北京上格云技术有限公司
 *            ;%@@$=$@@%*       *@@@$=%@@%;
 *               ::;::             ::;::                                              All rights reserved.
 *
 * ********************************************************************************************************************
 */

package com.persagy.server.sso

import io.swagger.annotations.ApiModel
import io.swagger.annotations.ApiModelProperty

/**
 * 用户信息
 *
 * @author  庞利祥(sybotan@126.com
 */
@ApiModel(description = "用户信息")
class User {
    /** id */
    @ApiModelProperty(value = "id", required = true)
    var id: String? = null

    /** 用户名 */
    @ApiModelProperty(value = "用户名", required = true)
    var userName: String? = null

    /** 密码 */
    @ApiModelProperty(value = "密码", required = true)
    var password: String? = null

    /** 真实姓名 */
    @ApiModelProperty(value = "真实姓名")
    var realName: String? = null

    /** 手机号码 */
    @ApiModelProperty(value = "手机号码，全局唯一")
    var phone: String? = null

    /** 邮箱 */
    @ApiModelProperty(value = "邮箱，全局唯一")
    var mail: String? = null

    /** 身份证号码 */
    @ApiModelProperty(value = "身份证号码，全局唯一")
    var certno: String? = null
} // Class User
